<?php

require_once("../common/binary.php");
require_once("../common/write_bmp.php");

function conv($f,$wh,$hh){
   $si=$wh*7*$hh;
   $out=str_repeat("\x00",$si);
   $p=0;
   for($y=$hh-1;$y>=0;$y--){
      for($x=0;$x<$wh;$x++){
         $c=getint1($f,$p);
         for($b=0;$b<7;$b++){
            if($c&1<<$b) $out[($y*$wh+$x)*7+$b]="\x01";
         }
      }
   }
/*   $out2=str_repeat("\x00",$si);
   for($i=0;$i<$si;$i++){
      if($out[$i]!=$out[$i-1] and $out[$i]!=$out[$i+1]){
         $out2[$i]=chr(2|($i%($wh*7))&1^ord($out[$i]));
      }else{
         $out2[$i]=$out[$i];
      }
   }
   return $out2;*/
   return $out;
}

$pal="\x00\x00\x00\x00". // black
     "\xFF\xFF\xFF\x00". // white
     "\x00\x80\xFF\x00". // orange
     "\xFF\x00\x00\x00". // blue
str_repeat("\x00",(256-4)*4);

$irpath="jmechner-Prince-of-Persia-Apple-II-c690818/04 Support/DRAZ/";
$orpath="deci/";

function scan($ipath,$opath){
   mkdir($opath);
   $id=opendir($ipath);
   while($fn=readdir($id)){
      $ipp=$ipath."/".$fn;
      $opp=$opath."/".$fn;
print $ipp."\r\n";
      if(is_file($ipp)){
         if(substr($fn,0,4)=="PAC."){ dopac($ipp,$opp); }
         elseif(substr($fn,0,4)=="IMG."){ doimg($ipp,$opp); }
         else{ doraw($ipp,$opp); }
      }
      if($fn[0]!="." and is_dir($ipp)) scan($ipp,$opp);
   }
   closedir($id);
}

function dopac($ipath,$opath){
   //
}

function doraw($ipath,$opath){
   //
}

function doimg($ipath,$opath){
   $fn=$ipath;
   $f=file_get_contents($fn);
      $sa=0;
      $p=$sa; printf("%05X to ",$sa);
//      $path=sprintf("outf/%s/%05X",$disk,$sa);
      @mkdir($opath);
      $n=getint1($f,$p); $ads=array();
      //if($n==0) $n=127;
      $rel=0x6000;
      for($i=0;$i<$n;$i++){ $ads[]=getint2($f,$p); /*$n=($ads[0]-$rel-1>>1)-1;*/ }
      $ea=getint2($f,$p); printf("%05X\r\n",$sa+$ea-$rel);
      for($i=0;$i<$n;$i++){
printf("frame %d\r\n",$i);
         $p=$sa+$ads[$i]-$rel;
         $wh=getint1($f,$p); $hh=getint1($f,$p);
         $dt=getstr($f,$p,$wh*$hh);
         $cv=conv($dt,$wh,$hh);
   global $pal;
//         write_bmp($path."/".s2($i,3).".bmp",$wh*8,$hh,$dt,$pal,1,false,$wh);
         write_bmp($opath."/".s2($i,3).".bmp",$wh*7,$hh,$cv,$pal,8,false,$wh*7);
      }
}

scan($irpath,$orpath);

?>