<?php

set_time_limit(0);

require_once("../common/binary.php");
require_once("../common/write_bmp.php");

// memowrite...
function putfile($fn,$s){
   $fp=fopen($fn,"wb");
   fwrite($fp,$s);
   fflush($fp);
   fclose($fp);
}

function dec(&$f,&$p){
   $l=40*192;
   $out=str_repeat("\x00",$l);
   $o=0;
   while($o<$l){
      $ch=$f[$p++];
      if($ch=="\xFE"){
         $r=ord($f[$p++]);
         $ch=$f[$p++]&"\x7F"; for($i=0;$i<$r;$i++) $out[$o++]=$ch;
      }else{
         $out[$o++]=$ch&"\x7F";
      }
   }
   $out=strrev($out);
   return $out;
}


function transp(&$f){
   $wh=40;
   $hh=192;
   $l=$wh*$hh;
   $p=0;
   $out=str_repeat("\x00",$l);
   for($x=0;$x<$wh;$x++){
      for($y=0;$y<$hh;$y++){
         $out[$y*$wh+$x]=$f[$p++];
      }
   }
   return $out;
}

function conv(&$f){
   $wh=280;
   $hh=192;
   $l=$wh*$hh;
   $p=0;
   $out=str_repeat("\x00",$l);
/*
   for($x=0;$x<$wh;$x+=7){
      for($y=0;$y<$hh;$y++){
         $a=ord($f[$p++]);
         for($xl=0;$xl<7;$xl++){
            $out[$y*$wh+$x+$xl]=chr($a>>$xl&1);
         }
      }
   }
*/
   $o=0;
   while($o<$l){
      $a=ord($f[$p++]);
      for($xl=0;$xl<7;$xl++){
         $out[$o++]=chr($a>>$xl&1);
      }
   }
   $si=$wh*$hh;
   $out2=str_repeat("\x00",$si);
   for($i=0;$i<$si;$i++){
      if($out[$i]!=$out[$i-1] and $out[$i]!=$out[$i+1]){
         $out2[$i]=chr(2|$i&1^ord($out[$i]));
      }else{
         $out2[$i]=$out[$i];
      }
   }
   return $out2;
   return $out;
}

function demix(&$f){
   $p=0;
   $out=str_repeat("\x00",40*192);
   for($y3=0;$y3<8;$y3++){
      for($y2=0;$y2<8;$y2++){
         for($y1=0;$y1<3;$y1++){
            $o=($y1*64+$y2*8+$y3)*40;
            for($x1=0;$x1<40;$x1++){
               $out[$o++]=$f[$p++];
            }
         }
         $p+=8;
      }
   }
   return $out;
}

//$arr=array(
//   "b"=>array(0x18C00)
//);

//$fn=$argv[1];

$pal="\x00\x00\x00\x00". // black
     "\xFF\xFF\xFF\x00". // white
     "\x00\x80\xFF\x00". // orange
     "\xFF\x00\x00\x00". // blue
str_repeat("\x00",(256-4)*4);

$irpath="jmechner-Prince-of-Persia-Apple-II-c690818/04 Support/DRAZ/";
$orpath="dec/";

function scan($ipath,$opath){
   mkdir($opath);
   $id=opendir($ipath);
   while($fn=readdir($id)){
      $ipp=$ipath."/".$fn;
      $opp=$opath."/".$fn;
print $ipp."\r\n";
      if(is_file($ipp)){
         if(substr($fn,0,4)=="PAC."){ dopac($ipp,$opp); }
         elseif(substr($fn,0,4)=="IMG."){ doimg($ipp,$opp); }
         else{ doraw($ipp,$opp); }
      }
      if($fn[0]!="." and is_dir($ipp)) scan($ipp,$opp);
   }
   closedir($id);
}

function dopac($ipath,$opath){
   global $pal;
   $fn=$ipath;
   $f=file_get_contents($fn);
   $p=0;
   $out=dec($f,$p);
   $out=transp($out);
   $dt=conv($out);
   write_bmp($opath.".bmp",280,192,$dt,$pal,8,false,280);
}

function doraw($ipath,$opath){
   global $pal;
   $fn=$ipath;
   $f=file_get_contents($fn);
   $p=0;
   $out=demix($f,$p);
//putfile($opath,$out);
   $dt=conv($out);
   write_bmp($opath.".bmp",280,192,$dt,$pal,8,false,280);
}

function doimg($ipath,$opath){
   //
}

//die(basename("a/b/c.d"));

mkdir("dec");
scan($irpath,$orpath);

?>